#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <time.h>

#define BACKLOG 2

void
traite_requete (int connexion)
{
  char* daytime;
  time_t temps;
  
  time (&temps);
  daytime = ctime (&temps);
  write (connexion, daytime, strlen (daytime));
}

int
attente (int port)
{
  int sock;
  int connexion;
  struct sockaddr_in serv_addr;
  struct sockaddr_in client_addr;
  int addrlen;
  int res;
  struct hostent* host;

  memset (&serv_addr, 0, sizeof (serv_addr));
  serv_addr.sin_family = AF_INET;
  serv_addr.sin_addr.s_addr   = htonl (INADDR_ANY);
  serv_addr.sin_port   = htons (port);
  
  /* On a toutes les donnes ncessaires. On peut crer la socket */
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock == -1)
    {
      perror ("socket");
      return -1;
    }

  /* La socket est cre. On peut spcifier le port sur lequel on veut
     couter */
  res = bind (sock, (struct sockaddr*) &serv_addr, sizeof (serv_addr));
  if (res == -1)
    {
      perror ("bind");
      return -1;
    }
  
  /* On met la socket en coute */
  res = listen (sock, BACKLOG);
  if (res == -1)
    {
      perror ("listen");
      return -1;
    }

  /* On attend les connexions */
  for ( ; ; )
    {
      printf ("Attente de connexion...\n");
      connexion = accept (sock, (struct sockaddr*) &client_addr, &addrlen);
      if (connexion < 0)
	{
	  perror ("accept");
	  exit (1);
	}
      /* On a accept une connexion */
      host = gethostbyaddr ((char*) &(client_addr.sin_addr.s_addr), 
			    sizeof (client_addr.sin_addr),
			    AF_INET);
      if (host == NULL)
	{
	  printf ("Connexion depuis la machine %s ...", inet_ntoa(client_addr.sin_addr.s_addr));
	}
      else
	{
	  printf ("Connexion depuis la machine %s ...", host->h_name);
	}
      
      traite_requete (connexion);

      printf ("Fin de la connexion.\n");
      close (connexion);
    }
  return -1;
}

int
main (int argc, char* argv[])
{
  int port;

  if (argc != 2)
    {
      fprintf (stderr, "Syntaxe : %s numero-port\n", argv[0]);
      exit (1);
    }

  port = atoi (argv[1]);
  printf ("Attente de connexion sur le port %d.\n", port);
  attente (port);
  exit (0);
}
